## xcffib 0.2.0

=== Makefile ===
GEN=./dist/build/xcffibgen/xcffibgen
AUTOPEP8=autopep8 --in-place --aggressive --aggressive

XCBVER=$(shell pkg-config --modversion xcb-proto)
XCBDIR=$(shell pkg-config --variable=xcbincludedir xcb-proto)
NCPUS=$(shell grep -c processor /proc/cpuinfo)
PARALLEL=$(shell which parallel)
CABAL=cabal --config-file=/dev/null

# you should have xcb-proto installed to run this
xcffib: $(GEN) module/*.py
	$(GEN) --input $(XCBDIR) --output ./xcffib
	cp ./module/*py ./xcffib/
	sed -i "s/__xcb_proto_version__ = .*/__xcb_proto_version__ = \"${XCBVER}\"/" xcffib/__init__.py

.PHONY: xcffib-fmt
xcffib-fmt: $(GEN) module/*.py
ifeq (${PARALLEL},)
	$(AUTOPEP8) ./xcffib/*.py
else
	find ./xcffib/*.py | parallel -j $(NCPUS) $(AUTOPEP8) '{}'
endif

dist:
	$(CABAL) configure --enable-tests

.PHONY: $(GEN)
$(GEN): dist
	$(CABAL) build

.PHONY: clean
clean:
	-$(CABAL) clean
	-rm -rf xcffib
	-rm -rf module/*pyc module/__pycache__
	-rm -rf tests/*pyc tests/__pycache__
	-rm -rf build *egg* *deb .pybuild

# A target for just running nosetests. Travis will run 'check', which does
# everything. (Additionally, travis uses separate environments where nosetests
# points to The Right Thing for each, so we don't need to do nosetests3.)
pycheck: xcffib
	nosetests -d
	nosetests3 -d

valgrind: xcffib
	valgrind --leak-check=full --show-leak-kinds=definite nosetests -d

newtests: $(GEN)
	$(GEN) --input ./tests/generator/ --output ./tests/generator/
	git diff tests

# These are all split out so make -j3 check goes as fast as possible.
.PHONY: lint
lint:
	flake8 --config=./tests/flake8.cfg ./module

.PHONY: htests
htests: $(GEN)
	$(CABAL) test

check: xcffib lint htests
	nosetests -d -v

deb:
	git buildpackage --git-upstream-tree=master
	lintian

deb-src:
	git buildpackage --git-upstream-tree=master -S

# make release ver=0.99.99
release: xcffib
ifeq (${ver},)
	@echo "no version (ver=) specified, not releasing."
else ifneq ($(wildcard ./xcffib.egg-info*),)
	@echo "xcffib.egg-info exists, not releasing."
else
	sed -i "s/version = .*/version = \"${ver}\"/" setup.py
	sed -r -i -e "s/(^version = \s*)[\"0-9\.]*/\1\"${ver}\"/" setup.py
	sed -r -i -e "s/(^version:\s*)[0-9\.]*/\1${ver}/" xcffib.cabal
	git commit -a -m "Release v${ver}"
	git tag v${ver}
	python setup.py sdist
	python setup.py sdist upload
endif

## xcffib 0.3.4

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,7 @@
 	$(GEN) --input $(XCBDIR) --output ./xcffib
 	cp ./module/*py ./xcffib/
 	sed -i "s/__xcb_proto_version__ = .*/__xcb_proto_version__ = \"${XCBVER}\"/" xcffib/__init__.py
+	python xcffib/ffi_build.py
 
 .PHONY: xcffib-fmt
 xcffib-fmt: $(GEN) module/*.py
@@ -83,4 +84,6 @@
 	git tag v${ver}
 	python setup.py sdist
 	python setup.py sdist upload
+	cabal sdist
+	cabal upload dist/xcffib-${ver}.tar.gz
 endif

=== debian/changelog ===
xcffib (0.3.4-1) unstable; urgency=medium

  * Version bump for cffi 1.0 and upstream release.
  * Closes: #790864

 -- Tycho Andersen <tycho@tycho.ws>  Mon, 20 Jul 2015 00:28:04 +0000

xcffib (0.2.0-1) unstable; urgency=low

  * Initial release.
  * Closes: #776178

 -- Tycho Andersen <tycho@tycho.ws>  Sun, 15 Feb 2015 07:41:13 -0700

## xcffib 0.3.6

=== Makefile ===
--- 
+++ 
@@ -36,6 +36,7 @@
 	-rm -rf module/*pyc module/__pycache__
 	-rm -rf tests/*pyc tests/__pycache__
 	-rm -rf build *egg* *deb .pybuild
+	-rm -rf .pc
 
 # A target for just running nosetests. Travis will run 'check', which does
 # everything. (Additionally, travis uses separate environments where nosetests

## xcffib 0.4.0

=== debian/changelog ===
xcffib (0.4.0-1) unstable; urgency=medium

  * include length parameter as required as xpyb does
  * fix struct packing for various extensions
  * Closes: #805234

 -- Tycho Andersen <tycho@tycho.ws>  Sun, 15 Nov 2015 18:17:57 -0700

xcffib (0.3.6-1) unstable; urgency=medium

  * Fix cffi/cairocffi dependency versions
  * Use a .so name that exists in the non-dev packages
  * Don't have a top level attribute called 'setup' so as to avoid confusing
    nose.
  * Closes: #796417

 -- Tycho Andersen <tycho@tycho.ws>  Fri, 21 Aug 2015 23:39:38 +0000

=== debian/control ===
Source: xcffib
Section: python
Priority: optional
Maintainer: Tycho Andersen <tycho@tycho.ws>
Build-Depends: debhelper (>= 9)
  , dh-python
  , pkg-config
  , ghc
  , xcb-proto
  , libxcb-render0-dev
  , libxcb1-dev
  , cabal-install
  , libghc-xcb-types-dev (>= 0.7.0)
  , libghc-language-python-dev (>= 0.4.0)
  , libghc-split-dev
  , libghc-optparse-applicative-dev (>= 0.5)
  , libghc-filemanip-dev
  , libghc-mtl-dev (>= 2.1)
  , libghc-test-framework-hunit-dev
  , libghc-attoparsec-dev
  , python-setuptools
  , python3-setuptools
  , python-autopep8
  , python-all
  , python3-all
  , python-all-dev
  , python3-all-dev
# testing
  , python-nose
  , python3-nose
  , xvfb
  , x11-apps
  , python-flake8
# Because xcffib imports itself in setup.py to do the cffi extension magic, all
# Depends: are also Build-depends:
  , python-six
  , python3-six
  , python-cffi (>= 1.1.0)
  , python3-cffi (>= 1.1.0)
  , libxcb1
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2
Standards-Version: 3.9.6
Homepage: https://github.com/tych0/xcffib
Vcs-Git: https://github.com/tych0/xcffib
Vcs-Browser: https://github.com/tych0/xcffib

Package: python-xcffib
Architecture: any
Depends: python-six
  , python-cffi (>= 1.1.0)
  , libxcb1
  , ${misc:Depends}
  , ${shlibs:Depends}
  , ${python:Depends}
Provides: ${python:Provides}
Description: This package is a python binding for XCB (Python 2)
 This package is intended to be a (mostly) drop-in replacement for xpyb. xpyb
 has an inactive upstream, several memory leaks, is python2 only and doesn't
 have pypy support. xcffib is a binding which uses python-cffi, which mitigates
 some of the issues described above. xcffib also builds bindings for 27 of the
 29 (xprint and xkb are missing) X extensions in 1.10.
 .
 This package installs the library for Python 2.

Package: python3-xcffib
Architecture: any
Depends: python3-six,
  , python3-cffi (>= 1.1.0)
  , libxcb1
  , ${misc:Depends}
  , ${shlibs:Depends}
  , ${python3:Depends}
Provides: ${python3:Provides}
Description: This package is a python binding for XCB (Python 3)
 This package is intended to be a (mostly) drop-in replacement for xpyb. xpyb
 has an inactive upstream, several memory leaks, is python2 only and doesn't
 have pypy support. xcffib is a binding which uses python-cffi, which mitigates
 some of the issues described above. xcffib also builds bindings for 27 of the
 29 (xprint and xkb are missing) X extensions in 1.10.
 .
 This package installs the library for Python 3.

## xcffib 0.4.2

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 	-$(CABAL) clean
 	-rm -rf xcffib
 	-rm -rf module/*pyc module/__pycache__
-	-rm -rf tests/*pyc tests/__pycache__
+	-rm -rf test/*pyc test/__pycache__
 	-rm -rf build *egg* *deb .pybuild
 	-rm -rf .pc
 
@@ -49,13 +49,13 @@
 	valgrind --leak-check=full --show-leak-kinds=definite nosetests -d
 
 newtests: $(GEN)
-	$(GEN) --input ./tests/generator/ --output ./tests/generator/
+	$(GEN) --input ./test/generator/ --output ./test/generator/
 	git diff tests
 
 # These are all split out so make -j3 check goes as fast as possible.
 .PHONY: lint
 lint:
-	flake8 --config=./tests/flake8.cfg ./module
+	flake8 --config=./test/flake8.cfg ./module
 
 .PHONY: htests
 htests: $(GEN)

=== debian/changelog ===
xcffib (0.4.2-2) unstable; urgency=medium

  * Removed unnecessary depends on python{3,}-cffi. (Closes: #833163)
  * Updated the Vcs-* fields to point to Debian packaging. (Closes: #837386)
  * Added a patch to handle endianness in test cases.

 -- Iain R. Learmonth <irl@debian.org>  Mon, 19 Sep 2016 11:59:15 +0100

xcffib (0.4.2-1) unstable; urgency=medium

  * New upstream version.
  * debian/patches/language-python.patch:
   - Removed this patch, newer haskell-language-python now in Debian.
  * debian/control:
   - Replaced maintainer with myself (adopting this package)
   - Fixed capitalisation errors in package synopsis
  * debian/copyright:
   - Updated file paths, no new licenses

 -- Iain R. Learmonth <irl@debian.org>  Sun, 29 May 2016 13:26:27 +0100

xcffib (0.4.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Only build for little-endian architectures. (Closes: #816139)

 -- Iain R. Learmonth <irl@debian.org>  Thu, 28 Apr 2016 13:33:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: xcffib
 Section: python
 Priority: optional
-Maintainer: Tycho Andersen <tycho@tycho.ws>
+Maintainer: Iain R. Learmonth <irl@debian.org>
 Build-Depends: debhelper (>= 9)
   , dh-python
   , pkg-config
@@ -11,7 +11,7 @@
   , libxcb1-dev
   , cabal-install
   , libghc-xcb-types-dev (>= 0.7.0)
-  , libghc-language-python-dev (>= 0.4.0)
+  , libghc-language-python-dev (>= 0.5.2)
   , libghc-split-dev
   , libghc-optparse-applicative-dev (>= 0.5)
   , libghc-filemanip-dev
@@ -25,6 +25,8 @@
   , python3-all
   , python-all-dev
   , python3-all-dev
+  , python-cffi
+  , python3-cffi
 # testing
   , python-nose
   , python3-nose
@@ -35,26 +37,23 @@
 # Depends: are also Build-depends:
   , python-six
   , python3-six
-  , python-cffi (>= 1.1.0)
-  , python3-cffi (>= 1.1.0)
   , libxcb1
 X-Python-Version: >= 2.6
 X-Python3-Version: >= 3.2
 Standards-Version: 3.9.6
 Homepage: https://github.com/tych0/xcffib
-Vcs-Git: https://github.com/tych0/xcffib
-Vcs-Browser: https://github.com/tych0/xcffib
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/xcffib.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/xcffib.git
 
 Package: python-xcffib
-Architecture: any
+Architecture: alpha amd64 arm64 armel armhf i386 mipsel ppc64el sh4 x32
 Depends: python-six
-  , python-cffi (>= 1.1.0)
   , libxcb1
   , ${misc:Depends}
   , ${shlibs:Depends}
   , ${python:Depends}
 Provides: ${python:Provides}
-Description: This package is a python binding for XCB (Python 2)
+Description: This package is a Python binding for XCB (Python 2)
  This package is intended to be a (mostly) drop-in replacement for xpyb. xpyb
  has an inactive upstream, several memory leaks, is python2 only and doesn't
  have pypy support. xcffib is a binding which uses python-cffi, which mitigates
@@ -66,13 +65,12 @@
 Package: python3-xcffib
 Architecture: any
 Depends: python3-six,
-  , python3-cffi (>= 1.1.0)
   , libxcb1
   , ${misc:Depends}
   , ${shlibs:Depends}
   , ${python3:Depends}
 Provides: ${python3:Provides}
-Description: This package is a python binding for XCB (Python 3)
+Description: This package is a Python binding for XCB (Python 3)
  This package is intended to be a (mostly) drop-in replacement for xpyb. xpyb
  has an inactive upstream, several memory leaks, is python2 only and doesn't
  have pypy support. xcffib is a binding which uses python-cffi, which mitigates

## xcffib 0.5.1

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,12 @@
 GEN=./dist/build/xcffibgen/xcffibgen
 AUTOPEP8=autopep8 --in-place --aggressive --aggressive
 
-XCBVER=$(shell pkg-config --modversion xcb-proto)
-XCBDIR=$(shell pkg-config --variable=xcbincludedir xcb-proto)
+XCBDIR?=$(shell pkg-config --variable=xcbincludedir xcb-proto)
+ifneq ($(XCBDIR),$(shell pkg-config --variable=xcbincludedir xcb-proto))
+	XCBVER=$(shell sed -e '1,/AC_INIT/d' $(XCBDIR)/../configure.ac | head -n 1 | tr -d ,[:blank:])
+else
+	XCBVER=$(shell pkg-config --modversion xcb-proto)
+endif
 NCPUS=$(shell grep -c processor /proc/cpuinfo)
 PARALLEL=$(shell which parallel)
 CABAL=cabal --config-file=/dev/null
@@ -12,7 +16,7 @@
 	$(GEN) --input $(XCBDIR) --output ./xcffib
 	cp ./module/*py ./xcffib/
 	sed -i "s/__xcb_proto_version__ = .*/__xcb_proto_version__ = \"${XCBVER}\"/" xcffib/__init__.py
-	python xcffib/ffi_build.py
+	@if [ "$(TRAVIS)" = true ]; then python xcffib/ffi_build.py; else python xcffib/ffi_build.py > /dev/null 2>&1 || python3 xcffib/ffi_build.py; fi
 
 .PHONY: xcffib-fmt
 xcffib-fmt: $(GEN) module/*.py
@@ -79,6 +83,7 @@
 	@echo "xcffib.egg-info exists, not releasing."
 else
 	sed -i "s/version = .*/version = \"${ver}\"/" setup.py
+	sed -i "s/__version__ = .*/__version__ = \"${ver}\"/" xcffib/__init__.py
 	sed -r -i -e "s/(^version = \s*)[\"0-9\.]*/\1\"${ver}\"/" setup.py
 	sed -r -i -e "s/(^version:\s*)[0-9\.]*/\1${ver}/" xcffib.cabal
 	git commit -a -m "Release v${ver}"

=== debian/changelog ===
xcffib (0.5.1-1build3) bionic; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 20 Dec 2017 19:12:31 +0100

xcffib (0.5.1-1build2) bionic; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Nov 2017 16:24:54 +0100

xcffib (0.5.1-1build1) bionic; urgency=medium

  * No-change rebuild for GHC ABI changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Nov 2017 06:18:47 +0100

xcffib (0.5.1-1) unstable; urgency=medium

  * New upstream version (Closes: #839760, #839314, #866543)
  * Removed redundant patch for big-endian architecture support
    (now supported upstream)
  * Added new build dependencies for libghc-{either,semigroups}-dev
  * Dropped unneeded python{,3}-dev build dependencies (Closes: #866544)

 -- Iain R. Learmonth <irl@debian.org>  Fri, 14 Jul 2017 23:17:41 +0100

=== debian/control ===
--- 
+++ 
@@ -18,13 +18,13 @@
   , libghc-mtl-dev (>= 2.1)
   , libghc-test-framework-hunit-dev
   , libghc-attoparsec-dev
+  , libghc-semigroups-dev
+  , libghc-either-dev
   , python-setuptools
   , python3-setuptools
   , python-autopep8
   , python-all
   , python3-all
-  , python-all-dev
-  , python3-all-dev
   , python-cffi
   , python3-cffi
 # testing

=== debian/rules ===
#!/usr/bin/make -f

DEB_ENABLE_TESTS = yes

override_dh_auto_configure:
	make xcffib
	dh_auto_configure

# we can't use setup.py clean here, since it checks for the existence of xcffib/
override_dh_auto_clean:
	make clean

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

## xcffib 0.8.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,3 @@
-GEN=./dist/build/xcffibgen/xcffibgen
 AUTOPEP8=autopep8 --in-place --aggressive --aggressive
 
 XCBDIR?=$(shell pkg-config --variable=xcbincludedir xcb-proto)
@@ -9,38 +8,39 @@
 endif
 NCPUS=$(shell grep -c processor /proc/cpuinfo)
 PARALLEL=$(shell which parallel)
-CABAL=cabal --config-file=/dev/null
+CABAL=cabal --config-file=./cabal.config
+GEN=$(CABAL) new-run exe:xcffibgen --
 
 # you should have xcb-proto installed to run this
-xcffib: $(GEN) module/*.py
+xcffib: module/*.py
 	$(GEN) --input $(XCBDIR) --output ./xcffib
 	cp ./module/*py ./xcffib/
 	sed -i "s/__xcb_proto_version__ = .*/__xcb_proto_version__ = \"${XCBVER}\"/" xcffib/__init__.py
 	@if [ "$(TRAVIS)" = true ]; then python xcffib/ffi_build.py; else python xcffib/ffi_build.py > /dev/null 2>&1 || python3 xcffib/ffi_build.py; fi
 
 .PHONY: xcffib-fmt
-xcffib-fmt: $(GEN) module/*.py
+xcffib-fmt: module/*.py
 ifeq (${PARALLEL},)
 	$(AUTOPEP8) ./xcffib/*.py
 else
 	find ./xcffib/*.py | parallel -j $(NCPUS) $(AUTOPEP8) '{}'
 endif
 
-dist:
-	$(CABAL) configure --enable-tests
+dist-newstyle:
+	$(CABAL) new-configure --enable-tests
 
-.PHONY: $(GEN)
-$(GEN): dist
-	$(CABAL) build
+.PHONY: gen
+gen: dist-newstyle
+	$(CABAL) new-build
 
 .PHONY: clean
 clean:
-	-$(CABAL) clean
+	-$(CABAL) new-clean
 	-rm -rf xcffib
 	-rm -rf module/*pyc module/__pycache__
 	-rm -rf test/*pyc test/__pycache__
 	-rm -rf build *egg* *deb .pybuild
-	-rm -rf .pc
+	-rm -rf .pc cabal.project.local*
 
 # A target for just running nosetests. Travis will run 'check', which does
 # everything. (Additionally, travis uses separate environments where nosetests
@@ -52,9 +52,9 @@
 valgrind: xcffib
 	valgrind --leak-check=full --show-leak-kinds=definite nosetests -d
 
-newtests: $(GEN)
+newtests:
 	$(GEN) --input ./test/generator/ --output ./test/generator/
-	git diff tests
+	git diff test
 
 # These are all split out so make -j3 check goes as fast as possible.
 .PHONY: lint
@@ -62,8 +62,8 @@
 	flake8 --config=./test/flake8.cfg ./module
 
 .PHONY: htests
-htests: $(GEN)
-	$(CABAL) test
+htests:
+	$(CABAL) new-test
 
 check: xcffib lint htests
 	nosetests -d -v
@@ -88,8 +88,8 @@
 	sed -r -i -e "s/(^version:\s*)[0-9\.]*/\1${ver}/" xcffib.cabal
 	git commit -a -m "Release v${ver}"
 	git tag v${ver}
-	python setup.py sdist
-	python setup.py sdist upload
-	cabal sdist
-	cabal upload dist/xcffib-${ver}.tar.gz
+	python3 setup.py sdist
+	python3 setup.py sdist upload
+	cabal new-sdist
+	cabal upload --publish dist-newstyle/sdist/xcffib-${ver}.tar.gz
 endif

=== debian/changelog ===
xcffib (0.8.1-0.8) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python2 support; Closes: #938840

 -- Sandro Tosi <morph@debian.org>  Mon, 17 Feb 2020 01:30:44 -0500

xcffib (0.8.1-0.7) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control
    - remove python-flake8 from b-d, no longer needed

 -- Sandro Tosi <morph@debian.org>  Fri, 14 Feb 2020 21:31:52 -0500

xcffib (0.8.1-0.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove build-depends on python-autopep8 (downgrades: 938840)
  * Fix clean target.

 -- Peter Michael Green <plugwash@debian.org>  Sun, 22 Dec 2019 01:57:12 +0000

xcffib (0.8.1-0.5) unstable; urgency=medium

  * Non-maintainer upload
  * Run testsuite, to see if hangs are real or not
    (they happened only once on a ppc64el launchpad instance, but it might
     have been a network glitch)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Sep 2019 11:47:56 +0200

xcffib (0.8.1-0.4) unstable; urgency=medium

  * Non-maintainer upload
  * Avoid internet connection by patching cabal to not use a configuration
    file (Closes: #938982)
  * Disable tests for now, they might hang

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Sep 2019 08:59:04 +0200

xcffib (0.8.1-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Also export DISPLAY variable

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 26 Jul 2019 09:55:31 +0200

xcffib (0.8.1-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * Export fake $HOME directory to avoid poisoning non-existing homes.
  * Bump xcb-types dependency to 0.10.0, to ensure the new version is picked
    up (used in tests and xcffibgen)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 26 Jul 2019 09:25:27 +0200

xcffib (0.8.1-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream release (Closes: #892648)
  * Build it everywhere again (Closes: #914005)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 24 Jul 2019 23:11:44 +0200

=== debian/control ===
Source: xcffib
Section: python
Priority: optional
Maintainer: Iain R. Learmonth <irl@debian.org>
Build-Depends: debhelper (>= 9)
  , dh-python
  , pkg-config
  , ghc
  , xcb-proto
  , libxcb-render0-dev
  , libxcb1-dev
  , cabal-install
  , libghc-xcb-types-dev (>= 0.10.0)
  , libghc-language-python-dev (>= 0.5.6)
  , libghc-split-dev
  , libghc-optparse-applicative-dev (>= 0.5)
  , libghc-filemanip-dev
  , libghc-mtl-dev (>= 2.1)
  , libghc-test-framework-hunit-dev
  , libghc-attoparsec-dev
  , libghc-semigroups-dev
  , libghc-either-dev
  , python3-setuptools
  , python3-all
  , python3-cffi
# testing
  , python3-nose
  , xvfb
  , x11-apps
# Because xcffib imports itself in setup.py to do the cffi extension magic, all
# Depends: are also Build-depends:
  , python3-six
  , libxcb1
Standards-Version: 3.9.6
Homepage: https://github.com/tych0/xcffib
Vcs-Git: https://anonscm.debian.org/git/collab-maint/xcffib.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/xcffib.git

Package: python3-xcffib
Architecture: any
Depends: python3-six,
  , libxcb1
  , ${misc:Depends}
  , ${shlibs:Depends}
  , ${python3:Depends}
Provides: ${python3:Provides}
Description: This package is a Python binding for XCB (Python 3)
 This package is intended to be a (mostly) drop-in replacement for xpyb. xpyb
 has an inactive upstream, several memory leaks, is python2 only and doesn't
 have pypy support. xcffib is a binding which uses python-cffi, which mitigates
 some of the issues described above. xcffib also builds bindings for 27 of the
 29 (xprint and xkb are missing) X extensions in 1.10.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

export HOME=$(CURDIR)/debian/cabalconfig
export DISPLAY=:0

override_dh_auto_configure:
	make xcffib
	dh_auto_configure

# we can't use setup.py clean here, since it checks for the existence of xcffib/
override_dh_auto_clean:
	make clean
	rm -rf debian/cabalconfig
	rm -rf .ghc.environment.*

%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/xcffib-$1\.tar\.gz/ \
  https://github.com/tych0/xcffib/tags .*/v?(\d\S*)\.tar\.gz

## xcffib 0.11.1

=== Makefile ===
--- 
+++ 
@@ -9,12 +9,13 @@
 NCPUS=$(shell grep -c processor /proc/cpuinfo)
 PARALLEL=$(shell which parallel)
 CABAL=cabal --config-file=./cabal.config
-GEN=$(CABAL) new-run exe:xcffibgen --
+GEN=$(CABAL) new-run -j$(NCPUS) exe:xcffibgen --
 
 # you should have xcb-proto installed to run this
 xcffib: module/*.py
 	$(GEN) --input $(XCBDIR) --output ./xcffib
 	cp ./module/*py ./xcffib/
+	touch ./xcffib/py.typed
 	sed -i "s/__xcb_proto_version__ = .*/__xcb_proto_version__ = \"${XCBVER}\"/" xcffib/__init__.py
 	@if [ "$(TRAVIS)" = true ]; then python xcffib/ffi_build.py; else python xcffib/ffi_build.py > /dev/null 2>&1 || python3 xcffib/ffi_build.py; fi
 
@@ -31,7 +32,7 @@
 
 .PHONY: gen
 gen: dist-newstyle
-	$(CABAL) new-build
+	$(CABAL) new-build -j$(NCPUS)
 
 .PHONY: clean
 clean:
@@ -41,13 +42,6 @@
 	-rm -rf test/*pyc test/__pycache__
 	-rm -rf build *egg* *deb .pybuild
 	-rm -rf .pc cabal.project.local*
-
-# A target for just running nosetests. Travis will run 'check', which does
-# everything. (Additionally, travis uses separate environments where nosetests
-# points to The Right Thing for each, so we don't need to do nosetests3.)
-pycheck: xcffib
-	nosetests -d
-	nosetests3 -d
 
 valgrind: xcffib
 	valgrind --leak-check=full --show-leak-kinds=definite nosetests -d
@@ -63,17 +57,10 @@
 
 .PHONY: htests
 htests:
-	$(CABAL) new-test
+	$(CABAL) new-test -j$(NCPUS) --enable-tests
 
 check: xcffib lint htests
-	nosetests -d -v
-
-deb:
-	git buildpackage --git-upstream-tree=master
-	lintian
-
-deb-src:
-	git buildpackage --git-upstream-tree=master -S
+	nose2 -v
 
 # make release ver=0.99.99
 release: xcffib
@@ -92,4 +79,5 @@
 	python3 setup.py sdist upload
 	cabal new-sdist
 	cabal upload --publish dist-newstyle/sdist/xcffib-${ver}.tar.gz
+	@echo "remember to push the tag!!!"
 endif

=== requirements.txt ===
flake8
autopep8
six
cffi>=0.8.2

=== debian/changelog ===
xcffib (0.11.1-2) unstable; urgency=medium

  * d/control: Set 'Architecture: all' and remove useless Depends

 -- Jerome Lebleu <jerome@maroufle.fr>  Sun, 28 Nov 2021 12:12:23 +0100

xcffib (0.11.1-1) unstable; urgency=medium

  [ Jerome Lebleu ]
  * New upstream version 0.11.1
  * New maintainer (Closes: #952121)
  * d/control:
    + Switch to debhelper-compat and level 13
    + Bump to Standards-Version 4.6.0
    + Make the Description more informative
    + Update the Build-Depends
    + Update the Vcs-* fields to Salsa
  * d/copyright: Use HTTPS in Format and Source
  * d/upstream: Add a metadata file
  * d/watch: Bump version to 4
  * Remove unused debian/license-reconcile.yml

  [ Nilesh Patra ]
  * d/rules: s/make/MAKE
  * d/control:
    + B-D on nose2 instead of nose
    + Annontate more test-only deps with nocheck
    + Change VCS-URLs to DPT
    + Set maintainer to DPT and uploader to Jerome
  * Add autopkgtests
  * Add d/salsa-ci.yml

 -- Jerome Lebleu <jerome@maroufle.fr>  Sat, 27 Nov 2021 17:04:57 +0530

=== debian/control ===
Source: xcffib
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Jerome Lebleu <jerome@maroufle.fr>
Build-Depends: cabal-install,
               debhelper-compat (= 13),
               dh-python,
               ghc (>= 8.0),
               libghc-attoparsec-dev,
               libghc-either-dev,
               libghc-filemanip-dev,
               libghc-language-python-dev (>= 0.5.6),
               libghc-mtl-dev (>= 2.1),
               libghc-optparse-applicative-dev (>= 0.13),
               libghc-split-dev,
               libghc-test-framework-hunit-dev,
               libghc-xcb-types-dev (>= 0.10.0),
               libxcb-render0-dev,
               libxcb1,
               libxcb1-dev,
               pkg-config,
               python3-all,
               python3-cffi,
               python3-nose2 <!nocheck>,
               python3-setuptools,
               python3-six,
               x11-apps <!nocheck>,
               xcb-proto,
               xvfb <!nocheck>
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://github.com/tych0/xcffib
Vcs-Git: https://salsa.debian.org/python-team/packages/xcffib.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/xcffib

Package: python3-xcffib
Architecture: all
Depends: libxcb1,
         python3-cffi,
         python3-six,
         ${misc:Depends},
         ${python3:Depends}
Description: CFFI-based Python binding for X
 xcffib is intended to be a (mostly) drop-in replacement for xpyb. xpyb has an
 inactive upstream, several memory leaks, is python2 only and doesn't have pypy
 support. xcffib is a binding which uses CFFI, which mitigates some of the
 issues described above. xcffib also builds bindings for 27 of the 29 (xprint
 and xkb are missing) X extensions in 1.10.

=== debian/rules ===
#!/usr/bin/make -f

export HOME=$(CURDIR)/debian/cabalconfig
export DISPLAY=:0

%:
	dh $@ --with python3 --buildsystem pybuild

override_dh_auto_configure:
	$(MAKE) xcffib
	dh_auto_configure

# we can't use setup.py clean here, since it checks for the existence of xcffib/
override_dh_auto_clean:
	$(MAKE) clean
	rm -rf debian/cabalconfig
	rm -rf .ghc.environment.*

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/xcffib-$1\.tar\.gz/ \
  https://github.com/tych0/xcffib/tags .*/v?(\d\S*)\.tar\.gz

## xcffib 1.5.0

=== Makefile ===
--- 
+++ 
@@ -9,15 +9,14 @@
 NCPUS=$(shell grep -c processor /proc/cpuinfo)
 PARALLEL=$(shell which parallel)
 CABAL=cabal --config-file=./cabal.config
-GEN=$(CABAL) new-run -j$(NCPUS) exe:xcffibgen --
+GEN=$(CABAL) new-run --minimize-conflict-set -j$(NCPUS) exe:xcffibgen --
 
 # you should have xcb-proto installed to run this
-xcffib: module/*.py
+xcffib: module/*.py xcffib.cabal $(shell find . -path ./test -prune -false -o -name \*.hs)
 	$(GEN) --input $(XCBDIR) --output ./xcffib
 	cp ./module/*py ./xcffib/
 	touch ./xcffib/py.typed
 	sed -i "s/__xcb_proto_version__ = .*/__xcb_proto_version__ = \"${XCBVER}\"/" xcffib/__init__.py
-	@if [ "$(TRAVIS)" = true ]; then python xcffib/ffi_build.py; else python xcffib/ffi_build.py > /dev/null 2>&1 || python3 xcffib/ffi_build.py; fi
 
 .PHONY: xcffib-fmt
 xcffib-fmt: module/*.py
@@ -40,11 +39,11 @@
 	-rm -rf xcffib
 	-rm -rf module/*pyc module/__pycache__
 	-rm -rf test/*pyc test/__pycache__
-	-rm -rf build *egg* *deb .pybuild
+	-rm -rf build *egg* *deb .pybuild dist
 	-rm -rf .pc cabal.project.local*
 
 valgrind: xcffib
-	valgrind --leak-check=full --show-leak-kinds=definite nosetests -d
+	valgrind --leak-check=full --show-leak-kinds=definite pytest-3 -v
 
 newtests:
 	$(GEN) --input ./test/generator/ --output ./test/generator/
@@ -59,8 +58,20 @@
 htests:
 	$(CABAL) new-test -j$(NCPUS) --enable-tests
 
+# The --builtin=CW is a hack to work around:
+# https://lists.freedesktop.org/archives/xcb/2022-December/011427.html
+# when that lands and all tested versions have it, we can
+# drop this.
+#
+# In the meantime, we can work around this in the binding if someone really needs it.
+ifeq ($(shell printf "$(XCBVER)\n1.16.0" | sort -V | grep -c 1.16.0), 1)
+CW_HACK=--builtins=CW
+endif
+
 check: xcffib lint htests
-	nose2 -v
+	flake8 -j$(NCPUS) --ignore=E128,E231,E251,E301,E302,E305,E501,F401,E402,W503,E741,E999 xcffib/*.py $(CW_HACK)
+	python3 -m compileall xcffib
+	pytest-3 -v --durations=3
 
 # make release ver=0.99.99
 release: xcffib
@@ -73,10 +84,11 @@
 	sed -i "s/__version__ = .*/__version__ = \"${ver}\"/" xcffib/__init__.py
 	sed -r -i -e "s/(^version = \s*)[\"0-9\.]*/\1\"${ver}\"/" setup.py
 	sed -r -i -e "s/(^version:\s*)[0-9\.]*/\1${ver}/" xcffib.cabal
-	git commit -a -m "Release v${ver}"
+	echo "Release v${ver}" > /tmp/xcffib.releasemsg
+	git commit -a -S -s --allow-empty-message -t /tmp/xcffib.releasemsg
 	git tag v${ver}
 	python3 setup.py sdist
-	python3 setup.py sdist upload
+	twine upload dist/xcffib-${ver}.tar.gz
 	cabal new-sdist
 	cabal upload --publish dist-newstyle/sdist/xcffib-${ver}.tar.gz
 	@echo "remember to push the tag!!!"

=== requirements.txt ===
flake8
autopep8
cffi>=0.8.2

=== debian/changelog ===
xcffib (1.5.0-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 1.5.0 (Closes: #1052375, #1054820)
  * remove obsolete dependency on python3-six
  * replace obsolete dependency pkg-config -> pkgconf
  * use new dh-sequence-python3
  * refresh patches
  * nose2 has been replaced by pytest

 -- Alexandre Detiste <tchet@debian.org>  Mon, 01 Apr 2024 23:49:33 +0200

xcffib (0.11.1-4) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Submit, Contact.
  * Update standards version to 4.6.1, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 20 Nov 2022 12:31:19 +0000

xcffib (0.11.1-3) unstable; urgency=medium

  * Team Upload.
  * Fix FTBFS with applying upstream commit as
    patch for parse.hs (Closes: #1017252)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 13 Oct 2022 16:01:38 +0530

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Jerome Lebleu <jerome@maroufle.fr>
 Build-Depends: cabal-install,
                debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                ghc (>= 8.0),
                libghc-attoparsec-dev,
                libghc-either-dev,
@@ -19,16 +19,15 @@
                libxcb-render0-dev,
                libxcb1,
                libxcb1-dev,
-               pkg-config,
+               pkgconf,
                python3-all,
                python3-cffi,
-               python3-nose2 <!nocheck>,
+               python3-pytest,
                python3-setuptools,
-               python3-six,
                x11-apps <!nocheck>,
                xcb-proto,
                xvfb <!nocheck>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/tych0/xcffib
 Vcs-Git: https://salsa.debian.org/python-team/packages/xcffib.git
@@ -38,7 +37,6 @@
 Architecture: all
 Depends: libxcb1,
          python3-cffi,
-         python3-six,
          ${misc:Depends},
          ${python3:Depends}
 Description: CFFI-based Python binding for X

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DISPLAY=:0
 
 %:
-	dh $@ --with python3 --buildsystem pybuild
+	dh $@ --buildsystem pybuild
 
 override_dh_auto_configure:
 	$(MAKE) xcffib

=== debian/tests/control ===
Tests: run-unit-tests
Depends: @, python3-all, python3-pytest, xvfb, x11-apps
Restrictions: allow-stderr
